// controls.h
// Scan keyboard for button presses
#include <keypadc.h>

void handleInput()
{
	// Scan keyboard for button presses
	kb_Scan();

	// Move player
	if (kb_Data[7] & kb_Down)
	{
		if (!(player.pos.y >= (LCD_HEIGHT - 32)))
		{
			player.pos.y += speed;
		}
	}
	if (kb_Data[7] & kb_Up)
	{
		if (!(player.pos.y <= 0))
		{
			player.pos.y -= speed;
		}
	}
	if (kb_Data[7] & kb_Left)
	{
		if (!(player.pos.x <= 0))
		{
			player.pos.x -= speed;
		}
	}
	if (kb_Data[7] & kb_Right)
	{
		if (!(player.pos.x >= (LCD_WIDTH - 32)))
		{
			player.pos.x += speed;
		}
	}

	// Spawn bullet on 2nd press
	if (kb_Data[1] & kb_2nd)
	{
		// If bullet has already been spawned (You cannot hold the button)
		if (bulletSpawned == 0)
		{
			spawnBullet((player.pos.x + 16), (player.pos.y + 8));
			bulletSpawned = 1;
		}
	}

	// Set bulletSpawned to false if button is let loose
	if (kb_Data[1] != kb_2nd)
	{
		bulletSpawned = 0;
	}

	// Spawn baddie on 2nd press
	if (kb_Data[1] & kb_Mode)
	{
		// If baddie has already been spawned (You cannot hold the button)
		if (baddieSpawned == 0)
		{
			spawnBaddie((LCD_WIDTH + 32), randInt(0, (LCD_HEIGHT - 32)));
			baddieSpawned = 1;
		}
	}

	// Set baddieSpawned to false if button is let loose
	if (kb_Data[1] != kb_Mode)
	{
		baddieSpawned = 0;
	}
}